package com.hfkj.dao;

import com.hfkj.entity.CouponDiscountUserRel;
import com.hfkj.entity.CouponDiscountUserRelExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface CouponDiscountUserRelMapper extends CouponDiscountUserRelMapperExt {
    @SelectProvider(type=CouponDiscountUserRelSqlProvider.class, method="countByExample")
    long countByExample(CouponDiscountUserRelExample example);

    @DeleteProvider(type=CouponDiscountUserRelSqlProvider.class, method="deleteByExample")
    int deleteByExample(CouponDiscountUserRelExample example);

    @Delete({
        "delete from coupon_discount_user_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into coupon_discount_user_rel (discount_id, discount_name, ",
        "discount_img, discount_type, ",
        "discount_condition, discount_price, ",
        "discount_percentage, user_id, ",
        "`status`, use_time, ",
        "create_time, use_end_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{discountId,jdbcType=BIGINT}, #{discountName,jdbcType=VARCHAR}, ",
        "#{discountImg,jdbcType=VARCHAR}, #{discountType,jdbcType=INTEGER}, ",
        "#{discountCondition,jdbcType=DECIMAL}, #{discountPrice,jdbcType=DECIMAL}, ",
        "#{discountPercentage,jdbcType=DECIMAL}, #{userId,jdbcType=BIGINT}, ",
        "#{status,jdbcType=INTEGER}, #{useTime,jdbcType=TIMESTAMP}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{useEndTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(CouponDiscountUserRel record);

    @InsertProvider(type=CouponDiscountUserRelSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(CouponDiscountUserRel record);

    @SelectProvider(type=CouponDiscountUserRelSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_name", property="discountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_img", property="discountImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_type", property="discountType", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_condition", property="discountCondition", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_percentage", property="discountPercentage", jdbcType=JdbcType.DECIMAL),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="use_time", property="useTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="use_end_time", property="useEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<CouponDiscountUserRel> selectByExample(CouponDiscountUserRelExample example);

    @Select({
        "select",
        "id, discount_id, discount_name, discount_img, discount_type, discount_condition, ",
        "discount_price, discount_percentage, user_id, `status`, use_time, create_time, ",
        "use_end_time, ext_1, ext_2, ext_3",
        "from coupon_discount_user_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_name", property="discountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_img", property="discountImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_type", property="discountType", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_condition", property="discountCondition", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_percentage", property="discountPercentage", jdbcType=JdbcType.DECIMAL),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="use_time", property="useTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="use_end_time", property="useEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    CouponDiscountUserRel selectByPrimaryKey(Long id);

    @UpdateProvider(type=CouponDiscountUserRelSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") CouponDiscountUserRel record, @Param("example") CouponDiscountUserRelExample example);

    @UpdateProvider(type=CouponDiscountUserRelSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") CouponDiscountUserRel record, @Param("example") CouponDiscountUserRelExample example);

    @UpdateProvider(type=CouponDiscountUserRelSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(CouponDiscountUserRel record);

    @Update({
        "update coupon_discount_user_rel",
        "set discount_id = #{discountId,jdbcType=BIGINT},",
          "discount_name = #{discountName,jdbcType=VARCHAR},",
          "discount_img = #{discountImg,jdbcType=VARCHAR},",
          "discount_type = #{discountType,jdbcType=INTEGER},",
          "discount_condition = #{discountCondition,jdbcType=DECIMAL},",
          "discount_price = #{discountPrice,jdbcType=DECIMAL},",
          "discount_percentage = #{discountPercentage,jdbcType=DECIMAL},",
          "user_id = #{userId,jdbcType=BIGINT},",
          "`status` = #{status,jdbcType=INTEGER},",
          "use_time = #{useTime,jdbcType=TIMESTAMP},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "use_end_time = #{useEndTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(CouponDiscountUserRel record);
}